define([
    'jquery',
    'mage/translate'
], function($) {
    "use strict";
    /*
     * The 'undefined' check if for M2 versions < 2.2 which load the validation before loading the page itself
    */
    return function() {
        $.validator.addMethod('validate-filoblu-firstname-lastname-sum-length', function(value, element, params) {
            if (typeof $(params.target).val() === 'undefined') {
                return true;
            }
            else {
                // +1 character is for the space between fields
                return ((parseInt(value.length + $(params.target).val().length) + 1 <= parseInt(params.sumLength)) && (parseInt(value.length) <= parseInt(params.length)));
            }
        }, function(params, element) {
            return $.mage.__('The field must be less or equal than %1 characters and the sum of firstname and lastname fields must be less or equal than %2 characters.').replace('%1', params.length).replace('%2', params.sumLength);
        });

        $.validator.addMethod('validate-filoblu-street-sum-length', function(value, element, params) {
            if (typeof $(params.target).val() === 'undefined') {
                return true;
            }
            else {
                // spaceBetweenFields: this is for counting spaces between street fields
                var spaceBetweenFields = 0;
                var streetsSum = value.length;
                $('input[name="street[]"]:not(' + params.target + ')').each(function(index, element_2) {
                    spaceBetweenFields += index != 0 ? $(element_2).val().length > 0 ? 1 : 0 : 0;
                    streetsSum += $(element_2).val().length;
                });
                streetsSum += spaceBetweenFields;
                return streetsSum <= params.length;
            }
        }, function(params, element) {
            return $.mage.__('All address fields must contain a maximum of %1 characters.').replace('%1', params.length);
        });

        $.validator.addMethod('validate-filoblu-company-street-sum-length', function(value, element, params) {
            if (typeof $(params.target).val() === 'undefined') {
                return true;
            }
            else {
                // spaceBetweenFields: this is for counting spaces between street fields
                var streetsSum = $('input[name="company"]').val().length;
                var spaceBetweenFields = ($('input[name="company"]').val().length) > 0 ? 1 : 0;
                $('input[name="street[]"]').each(function(index, element_2) {
                    spaceBetweenFields += index != 0 ? $(element_2).val().length > 0 ? 1 : 0 : 0;
                    streetsSum += $(element_2).val().length;
                });
                streetsSum += spaceBetweenFields;
                return streetsSum <= params.length;
            }
        }, function(params, element) {
            return $.mage.__('All address fields (including company) must contain a maximum of %1 characters.').replace('%1', params.length);
        });

        $.validator.addMethod('validate-filoblu-field-length', function(value, element, params) {
            if (typeof $(params.target).val() === 'undefined') {
                return true;
            }
            else {
                return parseInt($(params.target).val().length) <= parseInt(params.length);
            }
        }, function(params, element) {
            return $.mage.__('The field must be less or equal than %1 characters.').replace('%1', params.length);
        });
    }
});
